;PBEasyCrypt Inlcude
;Christian 2011

EnableExplicit

Procedure.i PasswordToMD5Key(Password.s)
  Protected Size.i, *Password, *Key, i.i
  Size.i = StringByteLength(Password, #PB_Ascii)
  *Password = AllocateMemory(Size + 1)
  PokeS(*Password, Password, -1, #PB_Ascii)
  Password = MD5Fingerprint(*Password, Size)
  Password = Password + ReverseString(Password)
  FreeMemory(*Password)
  *Key = AllocateMemory(32)
  For i = 0 To 31
    PokeA(*Key + i, Val("$" + Mid(Password, i * 2 + 1, 2)))
  Next
  ProcedureReturn *Key
EndProcedure

Procedure.s StringEncoder(String.s, *Key, CryptRandom = #True, Bits.i = 256)
  Protected InputSize.i, EncodedSize.i, Base64Size.i
  Protected *Input, *Encoded, *Base64
  Protected Result.s
  InputSize.i = StringByteLength(String, #PB_Ascii)
  If InputSize < 16 : InputSize = 16 : EndIf
  *Input = AllocateMemory(InputSize + 1)
  PokeS(*Input, String, -1, #PB_Ascii)
  EncodedSize = InputSize + 16
  *Encoded = AllocateMemory(EncodedSize)
  If Not CryptRandom Or ( CryptRandom And Not CryptRandomData(*Encoded, 16) )
    RandomData(*Encoded, 16)
  EndIf
  If AESEncoder(*Input, *Encoded + 16, InputSize, *Key, Bits, *Encoded, #PB_Cipher_CBC)
    FreeMemory(*Input)
    Base64Size = EncodedSize * 1.35 + 64
    *Base64 = AllocateMemory(Base64Size)
    Base64Size = Base64Encoder(*Encoded, EncodedSize, *Base64, Base64Size)
    FreeMemory(*Encoded)
    Result = PeekS(*Base64, Base64Size, #PB_Ascii)
    FreeMemory(*Base64)
    ProcedureReturn Result
  EndIf
  FreeMemory(*Input)
  FreeMemory(*Encoded)
EndProcedure

Procedure.s StringDecoder(String.s, *Key, Bits.i = 256)
  Protected Base64Size.i, InputSize.i, DecodedSize.i
  Protected *Base64, *Input, *Decoded
  Protected Result.s
  Base64Size.i = StringByteLength(String, #PB_Ascii)
  *Base64 = AllocateMemory(Base64Size + 1)
  PokeS(*Base64, String, -1, #PB_Ascii)
  InputSize = Base64Size + 64
  *Input = AllocateMemory(InputSize)
  InputSize = Base64Decoder(*Base64, Base64Size, *Input, InputSize)
  FreeMemory(*Base64)
  If InputSize >= 16
    DecodedSize = InputSize - 16
    *Decoded = AllocateMemory(DecodedSize)
    If AESDecoder(*Input + 16, *Decoded, DecodedSize, *Key, Bits, *Input, #PB_Cipher_CBC)
      Result = PeekS(*Decoded, DecodedSize, #PB_Ascii)
    EndIf
    FreeMemory(*Decoded) 
  EndIf
  FreeMemory(*Input) 
  ProcedureReturn Result
EndProcedure

Procedure DecodeFileToMemory(Filename.s, *Key)
  Protected File.i, Size.i, Modulo.i
  Protected CRC32.l
  Protected *Input, *Output, *IV, *Result
  File = ReadFile(#PB_Any, Filename)
  If File
    If ReadLong(File) = 22234433
      Modulo = ReadByte(File)
      *IV = AllocateMemory(16)
      ReadData(File, *IV, 16)
      Size = Lof(File) - 25
      *Input = AllocateMemory(Size)
      *Output = AllocateMemory(Size)
      ReadData(File, *Input, Size)
      If AESDecoder(*Input, *Output, Size, *Key, 256, *IV, #PB_Cipher_CBC)
        If Modulo
          Size = Size - 16 + Modulo
          *Output = ReAllocateMemory(*Output, Size)
        EndIf
        CRC32 = CRC32Fingerprint(*Output, Size)
        If ReadLong(File) = CRC32
          *Result = *Output
        EndIf
      EndIf
      FreeMemory(*IV)
      FreeMemory(*Input)
      If *Result = 0
        FreeMemory(*Output)
      EndIf
    EndIf
    CloseFile(File)
  EndIf
  ProcedureReturn *Result
EndProcedure
; IDE Options = PureBasic 4.60 Beta 3 (Windows - x64)
; CursorPosition = 70
; FirstLine = 49
; Folding = -
; EnableXP